variables:
  SKIP_RESOURCE_KINDS: ""
  SCHEMA_LOCATION: "schemas/{{ .Group }}.{{ .ResourceKind }}.json"

stages:
  - test

test:
  stage: test
  image:
    name: "curlimages/curl:7.85.0"
    entrypoint: [ash]
  only:
    - merge_requests
  cache:
    paths:
      - .bin
      - .kubeconform
    when: always
  before_script:
    - mkdir -p .kubeconform && mkdir -p .bin && cd .bin
    - |
      [[ -x kubeconform ]] || (curl -sSL https://github.com/yannh/kubeconform/releases/download/v0.4.14/kubeconform-linux-amd64.tar.gz | tar zxvf -)
    - |
      [[ -x jsonnet ]] || (curl -sSL https://github.com/google/go-jsonnet/releases/download/v0.18.0/go-jsonnet_0.18.0_Linux_x86_64.tar.gz | tar zxvf -)
    - cd ..
  script:
    # TODO: Fully validate all applications, not just `main`.
    - |
      set -euxo pipefail
      BOOLEANS="true false"
      for contour in $BOOLEANS; do
          for cni in $BOOLEANS; do
              printf '\n\n*** VALIDATING FOR CONTOUR: %s; CNI: %s\n\n' $contour $cni
              .bin/jsonnet \
                  -y -J libs -J vendor \
                  --tla-code "contourEnabled=$contour" \
                  -A 'kubernetesServer=https://kubernetes.default.svc' \
                  -A 'namePrefix=' \
                  -A 'domain=example.com' \
                  -A 'devDomain=example.dev' \
                  -A 'letsencryptServer=example.com' \
                  -A 'prometheusReplicas=1' \
                  --tla-code "linkerdCni=$cni" \
                  -A 'linkerdReplicas=1' \
                  -A "lokiReplicas=1" \
                  -A "observabilityRevision=main" \
                  -A "gitlabRunnerS3Endpoint=example.com" \
                  -A "gitlabRunnerS3Bucket=example" \
                  --tla-code 'enableObservabilityStack=true' \
                  --tla-code 'localS3=false' \
                  apps/main/main.jsonnet | .bin/kubeconform -strict -cache .kubeconform -schema-location "$SCHEMA_LOCATION" -schema-location default -skip "$SKIP_RESOURCE_KINDS"
          done
      done

detect-secrets:
  stage: test
  image: zricethezav/gitleaks:v8.13.0
  cache:
    paths: []
    key: gitleaks
  script:
    - gitleaks detect --source . -v
  only:
    - merge_requests
